Commerce Product Review
=======================

This module provides a review feature for Drupal Commerce products.

Drupal Commerce is the leading flexible eCommerce solution for Drupal,
powering over 60,000 online stores of all sizes.

[Issue Tracker](https://www.drupal.org/project/issues/commerce_product_review)

## Installation

It is recommended to use [Composer](https://getcomposer.org/) to get this module
with all dependencies:

```
composer require "drupal/commerce_product_review"
```

See the [Drupal](https://www.drupal.org/docs/8/extending-drupal-8/installing-modules-composer-dependencies)
documentation for more details.

### rateit.js Javascript library

The [rateit.js](https://github.com/gjunge/rateit.js) Javascript library is
required for displaying both rating values and rating form as stars. There are
two ways to include the library:

#### Install with Composer

If you have already installed the module via Composer, we recommend to do the
same with the rateit.js library. Changes are required to your composer.json file
to allow installing javascript libraries via composer correctly (in the required
destination path).

We highly recommend to use [Asset Packagist](https://asset-packagist.org) in
order to load Javascript libraries via Composer.

Add the following snippets into your project's composer.json file. If there are
already 'repositories' and/or 'extra' entries in your project's composer.json, merge
these new entries with the already existing entries.

Add this into the repositories section:

```
    "repositories": [
        {
            "type": "composer",
            "url": "https://asset-packagist.org"
        }
    ],
```

Add this to the extras section:

```
"extra": {
    "installer-types": [
        "bower-asset",
        "npm-asset"
    ],
    "installer-paths": {
        "web/libraries/{$name}": [
            "type:drupal-library",
            "type:bower-asset",
            "type:npm-asset"
        ],
    }
}
```

This specifies where the javascript library is installed in your project.

After that, run:

```
composer require "npm-asset/jquery.rateit"
```

#### Install Manually
[Download the library](https://github.com/gjunge/rateit.js/releases) and extract
the file under the "libraries" directory. Ensure, that the library's js and css
files are found within the following path: `libraries/jquery.rateit/scripts`

## Configuration

1. Install the module.
2. Go to the product review types page at `/admin/commerce/config/product-review-types`
3. Configure the "default" review type or create your own.  
    - On the edit page select which product types should be enabled for the given 
    product review type. You must select product types for the widget to appear.  
    - If you want to be notified of new product reviews enter an email address.  
    - You can optionally add your own fields to product review types, as well as 
    change the form and view display.
4. On the product type display configuration page 
(eg `/admin/commerce/config/product-types/default/edit/display`) ensure that 
"Overall rating" is enabled and placed in your desired location.
5. Adjust the permissions to your needs. By default, any user may view the
   published product reviews.  
   - Writing reviews is only allowed for authenticated users by default.  
   - Giving create access to guest users will not work as the module relies upon
   user accounts to enforce one review per person per product.  
   - New product reviews won't get published automatically without admin approval,
   unless you assign the "**Publish product review**" permission to the
   reviewing user's role.  

## Credits

<!--- cspell:disable -->
Commerce Product Review module was originally developed and is currently
maintained by [Mag. Andreas Mayr](https://www.drupal.org/u/agoradesign).

All initial development was sponsored by
[agoraDesign KG](https://www.agoradesign.at).
<!--- cspell:enable -->
