<?php

/**
 * @file
 * Post-update hooks for the Commerce Product Review module.
 */

/**
 * Migrate show_overview_link to link_display = 'overview'.
 */
function commerce_product_review_post_update_migrate_link_display() {
  $config_factory = \Drupal::configFactory();
  $config_storage = \Drupal::service('config.storage');

  $configs = $config_storage->listAll('core.entity_view_display.commerce_product.');
  foreach ($configs as $config_name) {
    $config = $config_factory->getEditable($config_name);
    $content = $config->get('content');

    // Check if the overall_rating field exists and uses stars formatter.
    if (!empty($content['overall_rating']) && $content['overall_rating']['type'] === 'commerce_product_review_overall_rating_stars') {
      $settings = $content['overall_rating']['settings'];

      // Migrate the old setting to the new format.
      $settings['link_display'] = $settings['show_overview_link'] ? 'overview' : 'none';
      unset($settings['show_overview_link']);

      // Update the config.
      $content['overall_rating']['settings'] = $settings;
      $config->set('content', $content);
      $config->save();
    }
  }
}
